#pragma once

namespace _pix_plot_qt_framework {

#include <pixqtlib_global.h>

class PIXQTLIB_EXPORT BibleOccasion
{
public:
   BibleOccasion(void);
   ~BibleOccasion(void);

private:
   int _nOccasion;
   QString _strOccasion;
   QString _strEnOccasion;

   int _nOccasionLine;
   int _nOccasionSection;

   int _iBook;
   int _iChapter;

   QVector<int>_viVerses;

   QString _strInKjvLine;
   QString _strKjvLine;
   QString _strShinkaiLine;
   QString _strKougoLine;

public:
   void Clear( void );

	BibleOccasion &operator=( const BibleOccasion &that );

   void SetOccasion( int iValue ) { _nOccasion = iValue; }
   void SetOccasion( QString strLine ) { _strOccasion = strLine; }
   void SetEnOccasion( void );
   void SetOccasionLine( int iValue ) { _nOccasionLine = iValue; }
   void SetOccasionSection( int iValue ) { _nOccasionSection = iValue; }

   void SetBook( int iValue ) { _iBook = iValue; }
   void SetChapter( int iValue ) { _iChapter = iValue; }

   void AddVerse( int iValue );
   void AddVerseSeq( int iStart, int iEnd );

   void SetInKjvLine( QString strLine ) { _strInKjvLine = strLine; }
   void SetKjvLinet( QString strLine ) { _strKjvLine = strLine; }
   void SetShinkaiLin( QString strLine ) { _strShinkaiLine = strLine; }
   void SetKougoLine( QString strLine ) { _strKougoLine = strLine; }

   //

   int GetOccasion( void ) { return _nOccasion; }
   QString GetNamOccasion( void ) { return _strOccasion; }
   QString GetEnOccasion( void ) { return _strEnOccasion; }
   int GetOccasionLine( void ) { return _nOccasionLine; }
   int GetOccasionSection( void ) { return _nOccasionSection; }

   int GetBook( void ) { return _iBook; }
   int GetChapter( void ) { return _iChapter; }

   QString GetInKjvLine( void ) { return _strInKjvLine; }
   QString GetKjvLinet( void ) { return _strKjvLine; }
   QString GetShinkaiLin( void ) { return _strShinkaiLine; }
   QString GetKougoLine( void ) { return _strKougoLine; }

   QString strVerseBuffer( void );
};

} // namespace 
