#pragma once

namespace _pix_plot_qt_framework {

#include <pixqtlib_global.h>

//
// ʓǂ̈
// قƂǂ̉BiblePlanUnitA2ȏ@ 
//

class BiblePlanChapterUnit;

class PIXQTLIB_EXPORT BiblePlanDay
{
public:
   enum {
      // not read at all
      DaysPlanNotRead = 0,
      // partially read
      DaysPlanPartRead,
      // read all chaoters for the day's assignment
      DaysPlanAllRead,
   } DaysReadStatus;

public:
   BiblePlanDay(void);
   ~BiblePlanDay(void);

private:
   int _nID;

   QVector<BiblePlanChapterUnit> _Units;

public:
   void Clear( void );
	BiblePlanDay &operator=( const BiblePlanDay &that );

   void Set( int nID, const QVector<BiblePlanChapterUnit> &list );

   int Size( void ) const;
   BiblePlanChapterUnit Unit( int iPos ) const;
   void setUnit( int iPos, BiblePlanChapterUnit unit );
   
   bool Save( QXmlStreamWriter *writer ) const; 
   bool Load( QXmlStreamReader *reader ); 

   short GetReadStatus( void );

   // make a list of chapters, verses to be shown on the table
   // separated by return
   QString ChaptersList( BibleAllBooks *pBL );

   // shorter list for the table
   QString ChaptersShortList( BibleAllBooks *pBL );
};

} // namespace 
