#pragma once

#include <QWidget>
#include <QtGui>

class SamplerWindow;

class ImageSideSplitter : public QSplitter
{
   Q_OBJECT
 
public:
   ImageSideSplitter( Qt::Orientation orientation, QWidget * parent = 0 );
   ~ImageSideSplitter();

protected:
   void resizeEvent( QResizeEvent* );

public:
   void SetMainWindow( SamplerWindow *pMain ) { _pMainWindow = pMain; }
   SamplerWindow *GetMainWindow( void ) { return _pMainWindow; }

   void SetSide( int iSide ) { _iSide = iSide; }
   int GetSide( void ) { return _iSide; }

private:
   // pointer to the main window
   SamplerWindow *_pMainWindow;

   int _iSide;
   
protected:   
   void showEvent( QShowEvent *eve );
};
